package Pass_control;
#
#

use strict;


sub open
{
  my ($pkg, $conf_obj) = @_;
  return (bless{conf=>$conf_obj}, $pkg);
}

sub user_pass_ok
{
    my ($obj, $login, $pass) = @_;
    my $return = 1;
    if (CORE::open(F, $obj->{conf}->get('prefix_dir')."/conf/password"))
    {
      my @crypted = <F>;
      close F;
      foreach my $line (@crypted)
      {
        if ($line=~/^$login\:/)
        {
          $line=~s/^$login\://;
          $line=~s/\s//g;
          my $salt = substr($login, 0, 2);
          if (crypt($pass, $salt) ne $line){$return = 0;}
        }
      }
    }
    return $return;
}

sub admin_pass_ok
{
    my ($obj, $login, $pass) = @_;
    my $return = 0;
    if ($obj->user_pass_ok($login, $pass) && $login eq 'admin')
    {
      $return =1;
    }
    return $return;
}


sub admin_is_logged
{
  my ($pkg,$http_cookie) = @_;
  $_=' ';s/\s//;#null $5 ...
  $_ = $http_cookie;
  s/admin_log\s*=\s*([^;]*)//;
  my $cookie_value=$1;
  $cookie_value=~s/\s//g;
  if ($cookie_value eq 'yes') {return 1;}
  else {return 0;}
}

sub get_logged_user
{
  my ($pkg,$http_cookie) = @_;
  $_=' ';s/\s//;#null $5 ...
  $_ = $http_cookie;
  s/user_log\s*=\s*([^;]*)//;
  my $cookie_value=$1;
  $cookie_value=~s/\s//g;
  return $cookie_value;
}

sub admin_log
{
  print "Set-Cookie: admin_log=yes\r\n";
  print "Set-Cookie: user_log=admin\r\n";
}

sub user_log
{
  my ($obj, $login) = @_;
  print "Set-Cookie: admin_log=no\r\n";
  print "Set-Cookie: user_log=$login\r\n";
}

sub admin_log_out
{
  print "Set-Cookie:  admin_log=no\r\n";
  print "Set-Cookie:  user_log=public\r\n";
}

sub user_log_out
{
  my ($obj) = @_;
  $obj->admin_log_out();
}


sub set_pass
{
  my ($obj, $login, $pass) = @_;
  my $salt = substr($login, 0, 2);
  CORE::open (F, $obj->{conf}->get('prefix_dir').'/conf/password');
  my @lines = <F>;
  CORE::close (F);
  my $new_content;
  my $changed=0;
  my $new_line = "$login:".crypt($pass, $salt)."\n";
  foreach my $line (@lines)
  {
      if ($line=~/^$login\:/)
      {
          $line = $new_line;
          $changed=1;
      }
      $new_content.=$line;
  }
  if (!$changed)
  {
      $new_content.=$new_line;
  }
  CORE::open(F, '>'.$obj->{conf}->get('prefix_dir').'/conf/password');
  print F $new_content;
  CORE::close (F);
  return $obj->user_pass_ok($login, $pass);
}

1;

